=== debian/changelog ===
got (0.119-1) unstable; urgency=medium

  * New upstream version 0.119

 -- Tobias Heider <me@tobhe.de>  Tue, 30 Sep 2025 13:06:52 +0200
